Bug 119753 - Direct formatting control text Highlighting mode <Esc> not toggling off if the control is clicked with a selection already made
Summary: Direct formatting control text Highlighting mode <Esc> not toggling off if th...
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Documentation (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: low minor
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Help-Changes-Features
  Show dependency treegraph
 
Reported: 2018-09-08 00:06 UTC by AaronPeterson
Modified: 2018-09-29 19:45 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description AaronPeterson 2018-09-08 00:06:48 UTC
Description:
At the end of a paragraph, I highlighted a word.

I then hit space, and the highlighting did not apply to the space, I then wrote more... and the highlighting jumped from the previous word to the new word that I was writing...   This might be OK if the space had been highlighted.. but it wasn't... there was a clear communication from libreoffice that I was no longer in highlighted text...  and it's not ok that it highlighted what I wrote after because I would have done an action to turn it off...

So the space needs to be properly highlighted to indicate what is going to happen.  I expected it to not be highlighted and my next word to not be highlighted...   but I'm also ok with it being highlighted and me doing something to turn off highlighting...   Of note, I had the word selected when I made it be highlighted, which makes me expect it to not apply to the space coming after it...  If I had clicked the button, then written the word, I would expect to click the button to end the highlight... 

Steps to Reproduce:
1.See above
2.
3.

Actual Results:
see above

Expected Results:
if I select text to apply formatting to,  ONLY that text should have fomatting applied to it...  the text typed after should not have the formatting applied...

But really this is about the space that came after it...  It's not special..  It should be treated like any other character.. It is so infuriating to have the computer tell me one behavior is occurring, then have it switch behavior afterwards.. that is the real bug.


Reproducible: Always


User Profile Reset: Yes



Additional Info:
[Information automatically included from LibreOffice]
Locale: en-US
Module: TextDocument
[Information guessed from browser]
OS: Windows (All)
OS is 64bit: no

Version: 6.1.0.3 (x64)
Build ID: efb621ed25068d70781dc026f7e9c5187a4decd1
CPU threads: 8; OS: Windows 10.0; UI render: default; 
Locale: en-US (en_US); Calc: group threaded
Comment 1 V Stuart Foote 2018-09-08 04:24:15 UTC
Can not confirm on Windows 10 Pro 64-bit en-US with
Version: 6.1.0.3 (x64)
Build ID: efb621ed25068d70781dc026f7e9c5187a4decd1
CPU threads: 8; OS: Windows 10.0; UI render: GL; 
Locale: en-US (en_US); Calc: group threaded

Selecting a word at end of paragraph and applying highlighting from Standard Toolbar. Typing a space receives the highlighting. 

Selecting some of the text run and from context menu Character dialog -> Highlighting apply none to remove the direct formatting, adding additional text to the highlighted run continues it and spaces *are* highlighted. Deleting the space back to the direct formatted highlighted run and adding a space back does not pick up the DF.  

Same in current master/6.2.0 build.
Comment 2 Regis Perdreau 2018-09-08 06:01:51 UTC
Not reproduced.
It's difficult to go out the highlight mode. Press the highlght icon from the tool bar even with "no fill" don't stop the highlight when you type next character.
Seems to have the behaviour of a draw function... i have to select the whole word to turn off the highlighting and set the cursor at another place

Is there any specification ? can't find any "highlight" section in help (en and fr) Need info.






Version: 6.2.0.0.alpha0+
Build ID: 8854cf29682bc2f02fba1901f967c7a94bc706d5
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: fr-FR (fr_FR.UTF-8); Calc: threaded

Version: 6.0.3.2
Build ID: 1:6.0.3-0ubuntu1
Threads CPU : 4; OS : Linux 4.15; UI Render : par défaut; VCL: x11; 
Locale : nl-NL (fr_FR.UTF-8); Calc: group
Comment 3 V Stuart Foote 2018-09-08 08:55:16 UTC
(In reply to Regis Perdreau from comment #2)
> ...
> It's difficult to go out the highlight mode. Press the highlght icon from
> the tool bar even with "no fill" don't stop the highlight when you type next
> character.

I think it is supposed to be a simple toggle with <Esc>. Does not seem to work on Windows build master/6.2.0; I found I had to use the Character dialog's Highlighting panel and set None. 

> Is there any specification ? can't find any "highlight" section in help (en
> and fr) Need info.
> 

Like this?
https://help.libreoffice.org/6.2/en-US/text/shared/02/02160000.html?&DbPAR=SHARED&System=WIN

Setting the Highlighting to None does either of two things--it will stop the highlighting of additional text entry (out of Highlight mode), or it will remove the highlighting of selection or of the text run where the text cursor is positioned.

For the text run in the middle of some highlightin, pay attention as it will leave the white space & punctuation highlighted if not selected. May need to make a selection rather than just positioning the text cursor.
Comment 4 Xisco Faulí 2018-09-10 16:49:47 UTC
Reproduced back to

LibreOffice 3.3.0 
OOO330m19 (Build:6)
tag libreoffice-3.3.0.4

Adding the UX team to decide whether the current behaviour should be changed or not.

@Olivier, I'm adding you because the  page mentioned in comment 3 has an incorrect  step 3 which doesn't seem to work. Maybe it should be removed from now...
Comment 5 Heiko Tietze 2018-09-11 06:20:00 UTC
(In reply to V Stuart Foote from comment #3)
> I think it is supposed to be a simple toggle with <Esc>. 

Why? Would be the same for Bold or any other toggle function and with character styles in mind it means escape switches back to Default/None/No Formattiing. Don't think that makes sense.
Comment 6 Cor Nouws 2018-09-12 19:23:01 UTC
- Current summary ("Direct formatting control text Highlighting mode <Esc> not toggling off") is a bug in Windows on master 6.2, according to VStuart
- Orignial summary ("Highlighted text magically expands to new text without warning") could not be confirmed by two others, and not by me either.
 - The original summary, is a WFM.
 - In case of the current summary, it is a bug. Still there, @vstuart?
Comment 7 V Stuart Foote 2018-09-12 21:16:50 UTC
While the help article notes <Esc> as toggling off the formatting, it does so only when in the bucket paint mode.

Difficult to determine what mode the formatting is in, the button does not take its active shading except when clicked and in paint mode.

So, as noted if done as applied Direct Formatting to a selection--it is hard to turn off the highlight mode.

Clicking the button again does not toggle--at odds with behavior of other direct formatting button actions like Bold, Italic, Underline or Strike through.

Steps to Reproduce:

1. type some text "aaaaaaaaaaaaa bbbbbbbbbbbbb cccccccc ddddddddd"
2. select some piece of the text "ccccccc"
3. click the Highlight button on the Formatting toolbar
4. position text cursor into the now highlighted portion
5. type some more text "dddd", note it picks up highlighting
6. type a " " space, note it picks up highlighting

--How do you turn off the highlighting without relocating the text cursor?
a. <Esc> does not work
b. clicking the Highlight toolbar button, enables paint mode

Meaning--the *only* way to end Highlight DF is select the last character, and use Context menu -> Character dialog's Highlight panel and set to None.

This is not the same as other Character direct formatting controls which respond to GUI button clicks.

Either allow the <Esc> to toggle it off in this mode as well, or adjust the Button action to show Highlight state and to toggle.
Comment 8 Maxim Monastirsky 2018-09-12 23:40:54 UTC
(In reply to V Stuart Foote from comment #7)
> While the help article notes <Esc> as toggling off the formatting
The previous items there are:

1. On the Formatting bar, click the Highlight Color icon.
2. Select the text that you want to highlight.

So that section clearly talks about the bucket mode only. And esp. as toggling off the formatting is actually covered by the next section "To Remove Highlighting". So while we might try to improve the wording, there is nothing really wrong with the help in that regard.

> a. <Esc> does not work
And it shouldn't, as it doesn't toggle off any other kind of formatting like bold or italic.

> Clicking the button again does not toggle--at odds with behavior of other
> direct formatting button actions like Bold, Italic, Underline or Strike
> through.
...
> b. clicking the Highlight toolbar button, enables paint mode
The problem here is that we try to have 2 different functions on top of a single button. We want it to toggle formatting like the other formatting buttons, and we want the bucket mode. But we can't do both at the same time, so how to decide what to do when the button is clicked? Does the user want to toggle the formatting of the current text, or to highlight another text? We can't read his mind. So what we do is this: If there is already some text selected, the button acts as a toggle button similar to the other formatting buttons, otherwise it just activates the bucket mode. It might be that this behavior doesn't fit someone's workflow, but there's nothing else we can do to keep both functions. And AFAIK that's the same behavior as in MS Word, so people coming from there should be familiar with it.

> Meaning--the *only* way to end Highlight DF is select the last character,
> and use Context menu -> Character dialog's Highlight panel and set to None.
It can be done with the toolbar button too, in one of two ways:

1. Click the dropdown arrow of the toolbar button, select "No Fill", and paint over the last character. (It might be reasonable to make this work also w/o selecting "No Fill".)

2. First select the last character, and then click the toolbar button (no painting is needed).
Comment 9 Xisco Faulí 2018-09-13 08:46:46 UTC
> > a. <Esc> does not work
> And it shouldn't, as it doesn't toggle off any other kind of formatting like
> bold or italic.

That's why it should be removed from the help page...
Comment 10 Maxim Monastirsky 2018-09-13 09:05:24 UTC
(In reply to Xisco Faulí from comment #9)
> > > a. <Esc> does not work
> > And it shouldn't, as it doesn't toggle off any other kind of formatting like
> > bold or italic.
> 
> That's why it should be removed from the help page...
No it shouldn't, as the help page should tell people how to turn off the bucket mode.
Comment 11 Cor Nouws 2018-09-19 15:07:55 UTC
(In reply to Maxim Monastirsky from comment #8)

> The problem here is that we try to have 2 different functions on top of a
> single button. We want it to toggle formatting like the other formatting
> buttons, and we want the bucket mode. But we can't do both at the same time,
> so how to decide what to do when the button is clicked? Does the user want
> to toggle the formatting of the current text, or to highlight another text?
> We can't read his mind. So what we do is this: If there is already some text
> selected, the button acts as a toggle button similar to the other formatting
> buttons, otherwise it just activates the bucket mode. It might be that this
> behavior doesn't fit someone's workflow, but there's nothing else we can do
> to keep both functions. And AFAIK that's the same behavior as in MS Word, so
> people coming from there should be familiar with it.

Indeed. IMO a simple WFM
Comment 12 Heiko Tietze 2018-09-19 18:31:47 UTC
The discussion indicates that we probably have a documentation issue (component was Writer). If you don't think so, please close as WFM.